/*
 * sht4x.c
 *
 *  Created on: Jun 8, 2021
 *      Author: user
 */

#include "sht4x.h"

sht4x_context_t *sht4x_context;

int sht4x_init(sht4x_context_t *context)
{
	sht4x_context = context;
}

void i2c_transmit(uint8_t address, uint8_t *buffer, int len)
{
	LL_I2C_HandleTransfer(sht4x_context->i2c, address, LL_I2C_ADDRESSING_MODE_7BIT, len,
			LL_I2C_MODE_AUTOEND, LL_I2C_GENERATE_START_WRITE);
	int i = 0;
	while (!LL_I2C_IsActiveFlag_STOP(sht4x_context->i2c)) {
		if (LL_I2C_IsActiveFlag_TXE(sht4x_context->i2c)) {
			if (i < len) {
				LL_I2C_TransmitData8(sht4x_context->i2c, buffer[i++]);
			}
		}
	}
	LL_I2C_ClearFlag_STOP(sht4x_context->i2c);
}

void i2c_receive(uint8_t address, uint8_t *buffer, int len)
{
	LL_I2C_HandleTransfer(sht4x_context->i2c, address, LL_I2C_ADDRESSING_MODE_7BIT, len,
				LL_I2C_MODE_AUTOEND, LL_I2C_GENERATE_START_READ);
	int i = 0;
	while (!LL_I2C_IsActiveFlag_STOP(sht4x_context->i2c)) {
		if (LL_I2C_IsActiveFlag_RXNE(sht4x_context->i2c)) {
			if (i < len) {
				buffer[i++] = LL_I2C_ReceiveData8(sht4x_context->i2c);
			}
		}
	}
	LL_I2C_ClearFlag_STOP(sht4x_context->i2c);
}

int sht4x_send_cmd(sht4x_cmd_t cmd)
{

}

int sht4x_read_data(uint8_t *buffer, int len)
{

}

int sht4x_measure(int *temperature, int *relative_humidity)
{
	uint8_t buffer[32];

	// start measurement
	buffer[0] = START_MEAS_HIGH_PRECISION;
	i2c_transmit(SHT4X_I2C_ADDRESS, buffer, 1);
	// delay TODO
	volatile int j,k;
	for (j = 0; j < 100000; j++);
	// read out
	i2c_receive(SHT4X_I2C_ADDRESS, buffer, 6);
	// TODO

	uint32_t t_ticks = (buffer[0] << 8) + buffer[1];
	uint32_t rh_ticks = (buffer[3] << 8) + buffer[4];
	int t_degC = -45 + 175 * t_ticks / 65535;
	int rh_pRH = -6 + 125 * rh_ticks / 65535;
	if (rh_pRH > 100) {
			rh_pRH = 100;
	}
	if (rh_pRH < 0) {
		rh_pRH = 0;
	}
	*temperature = t_degC;
	*relative_humidity = rh_pRH;
}
